<template>
  <div>
    <conversation
    v-bind.sync='Conversation'
    v-on:submit='submit'
    v-on:cancel='cancel'>
    </conversation>
  </div>
</template>

<script>
import conversation from '@/components/employeePanel/Conversation.vue';
import { mapGetters } from 'vuex';
import { getAuthenticatedUser } from '@/fb';
import Conversation from '@/models/Conversation';
import ConversationList from '@/models/ConversationList';

export default {
  components: {
    conversation,
  },
  data() {
    return {
      Conversation: new Conversation(),
    };
  },
  props: {
    id: {
      type: String,
      required: true,
    },
  },
  created() {
    console.log('this is leave id  ', this.id);
  },
  computed: {
    ...mapGetters({
      snackbarText: 'getSnackbarText',
      showSnackbar: 'getShowSnackbar',
      user: 'getUser',
    }),
  },
  mounted() {
    getAuthenticatedUser().then((user) => {
      console.log('Got user: ', user);
      this.Conversation.uid = user.uid;
      this.Conversation.id = this.id;
      this.conversationList = new ConversationList({
        uid: user.uid,
        id: this.id,
        className: Conversation.getClassName(),
      });
      console.log('this function work', this.conversationList);
      this.conversationList
        .fetch2({ orderBy: 'sentAt', paginate: true })
        .then((page) => {
          this.notes = page;
          console.log('this is conversation', this.notes);
        });
    });
  },
  methods: {
    submit() {
      console.log('inside submit method of conversation');
      this.Conversation.create().then(() => {
        console.log('Done creating note', this.Conversation.id);
        this.$store.dispatch('setSnackbarText', 'sent message successfully');
        this.$store.dispatch('setShowSnackbar', true);
        this.$router.replace({ name: 'Conversation' });
      });
    },
    cancel() {
      this.$router.replace({ name: 'Conversation' });
    },
  },
};
</script>
